//
// audiodev.cpp
//
// This program is supposed to test the audiodev class.
//
// audiodev_test.cpp,v 1.3 2003/06/23 12:01:22 frenger Exp
//

#include <iostream>
#include <cstdlib>

#include "itbase.h"
#include "srccode/audiodev.h"

using std::cout;
using std::endl;
using std::cerr;

#if defined(__CYGWIN__) || defined(__APPLE__)

int main()
{
  cout << "IT++ does not support sound in the Cygwin or the Apple envirionments. Sorry."
       << endl;

  return 0;
}

#else

int main(int argc, char *argv[])
{
    double f=440.0;

    if (argc > 1)
	f = atof(argv[1]);

    Audio_Play_Device audio(1.0, 8000);
    Sine_Source     s0(f / 8000);
    Triangle_Source s1(f / 8000);
    Sawtooth_Source s2(f / 8000);
    Square_Source   s3(f / 8000);
    Impulse_Source  s4(f / 8000);

    if (!audio.play(s0(8000)))
	cerr << "Could not play!" << endl;
    if (!audio.play(s1(8000)))
	cerr << "Could not play!" << endl;
    if (!audio.play(s2(8000)))
	cerr << "Could not play!" << endl;
    if (!audio.play(s3(8000)))
	cerr << "Could not play!" << endl;
    if (!audio.play(s4(8000)))
	cerr << "Could not play!" << endl;

    return 0;
}

#endif //__CYGWIN__
