#include "itcomm.h"

using std::cout;
using std::endl;
using namespace itpp;

int main()
{
  RNG_reset(12345);

  Modulator_2d my_mod;
  QAM qam16(16);
  my_mod.set(qam16.get_symbols(),qam16.get_bitmap());

  bvec tx_bits = randb(8);
  cvec tx_symbols = my_mod.modulate_bits(tx_bits);
  double N0 = 0.1;
  cvec noise = sqrt(N0/2.0) * randn_c(tx_symbols.size());
  cvec rx_symbols = tx_symbols + noise;

  vec softbits, softbits_approx;
  my_mod.demodulate_soft_bits(rx_symbols,N0,softbits);
  my_mod.demodulate_soft_bits_approx(rx_symbols,N0,softbits_approx);

  cout << "tx_bits         = " << tx_bits << endl;
  cout << "tx_symbols      = " << tx_symbols << endl;
  cout << "rx_symbols      = " << rx_symbols << endl;
  cout << "softbits        = " << softbits << endl;
  cout << "softbits_approx = " << softbits_approx << endl;
}







